#! /usr/bin/ruby
# -*- coding: euc-jp -*-

# Ʊž׻襹ץ
# == 
# * ΥץȤƱž¸η̤οޤΤǤ.
# * ΥץȤǤ, gpview, fig_heatflux-lat-dependence.rb ʤɤ
#   ץȤȤ.
# * Ѥˤ, fig_heatflux-lat-dependence.rb ʤɤǼ
#   ǥ쥯ȥꤹɬפ.
#   Τ, script_dir Ŭ񤭴ͤФʤʤ.
#
# == ץ
# --time_start ϻ
# --time_end   λ
# --wsn        . ps ä --wsn=2
# --prefix     եդƬ
#
# == USAGE
#   % fig_SyncRot.rb --time_start=731 --time_end=1095 --wsn=2 --prefix=EXPNAME_
#
# == 
# * 2013-6-19  


require "getoptlong"        # for option_parse
require "numru/ggraph"
include NumRu

script_dir = "/GFD_Dennou_Work3/momoko/SyncRotEarthRad/script"
## ץ
parser = GetoptLong.new
parser.set_options(
        ###    global option   ###
       ['--time_start',              GetoptLong::REQUIRED_ARGUMENT],
       ['--time_end',                GetoptLong::REQUIRED_ARGUMENT],
       ['--qvap_name',     GetoptLong::REQUIRED_ARGUMENT],
       ['--cint_cloud',              GetoptLong::REQUIRED_ARGUMENT],
       ['--range_cloud',             GetoptLong::REQUIRED_ARGUMENT],
       ['--cint_surfh2ovapflux',              GetoptLong::REQUIRED_ARGUMENT],
       ['--range_surfh2ovapflux',             GetoptLong::REQUIRED_ARGUMENT],
       ['--cint_prcp',              GetoptLong::REQUIRED_ARGUMENT],
       ['--range_prcp',             GetoptLong::REQUIRED_ARGUMENT],
       ['--cint_slr',              GetoptLong::REQUIRED_ARGUMENT],
       ['--range_slr',             GetoptLong::REQUIRED_ARGUMENT],
       ['--fact_qvaptrnsprt',        GetoptLong::REQUIRED_ARGUMENT],
       ['--vecunit_qvaptrnsprt',     GetoptLong::REQUIRED_ARGUMENT],
       ['--wsn',                     GetoptLong::REQUIRED_ARGUMENT],
       ['--prefix',                  GetoptLong::REQUIRED_ARGUMENT]
                   )
parser.each_option do |name, arg|
    eval "$OPT_#{name.sub(/^--/, '').gsub(/-/, '_')} = '#{arg}'"  # strage option value to $OPT_val
end

default_prefix = ''
default_prefix = Dir.pwd.split('/')[-1] + '_'

prefix = ($OPT_prefix||default_prefix)

wsn = ($OPT_wsn||4)

fact_qvaptrnsprt = ($OPT_fact_qvaptrnsprt||'0.3')
vecunit_qvaptrnsprt = ($OPT_vecunit_qvaptrnsprt||'0.2')

range_stream = ($OPT_range_stream||'-100:100')
minval_stream = range_stream.split(':')[0].to_f
maxval_stream = range_stream.split(':')[1].to_f

cint_cloud = ($OPT_cint_cloud||0.05).to_s
range_cloud = ($OPT_range_cloud||'0:2').to_s
 
cint_surfh2ovapflux = ($OPT_cint_surfh2ovapflux||1.0e-5).to_s
range_surfh2ovapflux = ($OPT_range_surfh2ovapflux||'0:1e-4').to_s

cint_prcp = ($OPT_cint_prcp||5.0e-6).to_s
range_prcp = ($OPT_range_prcp||'1e-6:1e-4').to_s

cint_slr = ($OPT_cint_slr||10).to_s
range_slr = ($OPT_range_slr||'100:420').to_s


time_start = ($OPT_time_start||1).to_s
time_end = ($OPT_time_end||9999).to_s

timespan = time_start + ':' + time_end

qvap_name = ($OPT_qvap_name||'QH2OVap')

# dennou-h ǥ꤬­ʤʤ, Ǹ 300 ˤ.

#p time_end.class

# äޤǤ 289 Ƥ.
value_time_start_newdata = time_end.to_i - 200
time_start_newdata = value_time_start_newdata.to_s

# Ψ ϥѹƽϤΤΤϤ.
#system("{script_dir}/fig_CoolRate.rb --time_start=#{time_start} --time_end=#{time_end} --wsn=#{wsn} --prefix=#{$OPT_prefix}")


# 2 ǡ ʿʬ
if File.exist?("#{prefix}SurfTemp.png") then
  puts("MESSAGE: #{prefix}SurfTemp.png exists. process skipped.")
else
  # for SyncRot with increased S
  system("gpview SurfTemp.nc@SurfTemp,time=#{timespan} --mean time --range=160:340 --wsn=#{wsn} --int=5 --noannotate && convert -rotate 90 dcl.pdf #{prefix}SurfTemp.png")
  # old version
  system("gpview SurfTemp.nc@SurfTemp,time=#{timespan} --mean time --range=160:340 --wsn=#{wsn} --int=5 --noannotate && convert -rotate 90 dcl.pdf #{prefix}SurfTemp.png")
# for standard of S=1366
#  system("gpview SurfTemp.nc@SurfTemp,time=#{timespan} --mean time --range=180:330 --wsn=#{wsn} --cint=5 --noannotate && dclpsrot dcl.ps > #{prefix}SurfTemp.ps && convert #{prefix}SurfTemp.ps #{prefix}SurfTemp.png")
end

if File.exist?("#{prefix}SurfTemp_Ecolor.png") then
  puts("MESSAGE: #{prefix}SurfTemp_Ecolor.png exists. process skipped.")
else
  system("gpview SurfTemp.nc@SurfTemp,time=#{timespan} --mean time --wsn=#{wsn} --noannotate --levels 999,210,220,230,240,250,260,270,280,290,300,999 --pattern 20999,29999,40999,45999,50999,55999,60999,70999,80999,85999,90999 && convert -rotate 90 dcl.pdf #{prefix}SurfTemp_Ecolor.png")
end

if File.exist?("#{prefix}OLR.png") then
  puts("MESSAGE: #{prefix}OLR.png exists. process skipped.")
else
#  system("gpview OLR.nc@OLR,time=#{timespan} --mean time --wsn=#{wsn} --noannotate --sint=10 --range=130:440 && dclpsrot dcl.ps > #{prefix}OLR.ps && convert #{prefix}OLR.ps #{prefix}OLR.png")
  system("gpview OLR.nc@OLR,time=#{timespan} --mean time --wsn=#{wsn} --noannotate --sint=10 --range=130:440 && convert -rotate 90 dcl.pdf #{prefix}OLR.png")
end

if File.exist?("#{prefix}OLRA.png") then
  puts("MESSAGE: #{prefix}OLRA.png exists. process skipped.")
else
  system("gpview OLRA.nc@OLRA,time=#{timespan} --mean time --wsn=#{wsn} --noannotate --cint=10 --range=100:420 && convert -rotate 90 dcl.pdf #{prefix}OLRA.png")
end

if File.exist?("#{prefix}OLRA_Ecolor.png") then
  puts("MESSAGE: #{prefix}OLRA_Ecolor.png exists. process skipped.")
else
  system("gpview OLRA.nc@OLRA,time=#{timespan} --mean time --wsn=#{wsn} --noannotate --levels 999,100,120,140,160,180,200,220,240,260,280,300,999 --pattern 10999,16999,20999,24999,29999,35999,40999,45999,55999,70999,80999,90999 && convert -rotate 90 dcl.pdf #{prefix}OLRA_Ecolor.png")
end

if File.exist?("#{prefix}SLRA.png") then
  puts("MESSAGE: #{prefix}SLRA.png exists. process skipped.")
else
  system("gpview SLRA.nc@SLRA,time=#{timespan} --mean time --wsn=#{wsn} --noannotate --cint=#{cint_slr} --range=#{range_slr} && convert -rotate 90 dcl.pdf #{prefix}SLRA.png")
end

if File.exist?("#{prefix}Rain.png") then
  puts("MESSAGE: #{prefix}Rain.png exists. process skipped.")
else
  system("gpview Rain.nc@Rain,time=#{timespan} --mean time --range=0:1e-4 --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}Rain.png")
end

if File.exist?("#{prefix}PRCP.png") then
  puts("MESSAGE: #{prefix}PRCP.png exists. process skipped.")
else
  system("gpview PRCP.nc@PRCP,time=#{timespan} --mean time --range=#{range_prcp} --cint=#{cint_prcp} --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}PRCP.png")
end

if File.exist?("#{prefix}PRCP_Ecolor.png") then
  puts("MESSAGE: #{prefix}PRCP_Ecolor.png exists. process skipped.")
else
  system("gpview PRCP.nc@PRCP,time=#{timespan} --mean time --range=0:1e-3 --cint=5e-5 --wsn=#{wsn} --noannotate --levels 999,0,1e-5,2e-5,4e-5,8e-5,1.2e-4,1.6e-4,2.0e-4,2.4e-4,2.8e-4,3.2e-4,999 --pattern 99999,20999,29999,35999,40999,45999,55999,65999,70999,75999,80999,90999 && convert -rotate 90 dcl.pdf #{prefix}PRCP_Ecolor.png")
end

if File.exist?("#{prefix}SurfH2OVapFluxU.png") then
  puts("MESSAGE: #{prefix}SurfH2OVapFluxU.png exists. process skipped.")
else
  system("gpview SurfH2OVapFluxU.nc@SurfH2OVapFluxU,time=#{timespan} --mean time --cint=#{cint_surfh2ovapflux} --range=#{range_surfh2ovapflux} --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}SurfH2OVapFluxU.png")
end

if File.exist?("#{prefix}Evap.png") then
  puts("MESSAGE: #{prefix}Evap.png exists. process skipped.")
else
  system("gpview Evap.nc@Evap,time=#{timespan} --mean time --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}Evap.png")
end

if File.exist?("#{prefix}EvapU.png") then
  puts("MESSAGE: #{prefix}EvapU.png exists. process skipped.")
else
  system("gpview EvapU.nc@EvapU,time=#{timespan} --mean time --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}EvapU.png")
end

if File.exist?("#{prefix}Sens.png") then
  puts("MESSAGE: #{prefix}Sens.png exists. process skipped.")
else
  system("gpview Sens.nc@Sens,time=#{timespan} --mean time --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}Sens.png")
end

if File.exist?("#{prefix}SensA.png") then
  puts("MESSAGE: #{prefix}SensA.png exists. process skipped.")
else
  system("gpview SensA.nc@SensA,time=#{timespan} --mean time --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}SensA.png")
end

if File.exist?("#{prefix}OSR.png") then
  puts("MESSAGE: #{prefix}OSR.png exists. process skipped.")
else
  system("gpview OSR.nc@OSR,time=#{timespan} --mean time --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}OSR.png")
end

if File.exist?("#{prefix}OSRA.png") then
  puts("MESSAGE: #{prefix}OSRA.png exists. process skipped.")
else
  system("gpview OSRA.nc@OSRA,time=#{timespan} --mean time --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}OSRA.png")
end

if File.exist?("#{prefix}SSR.png") then
  puts("MESSAGE: #{prefix}SSR.png exists. process skipped.")
else
  system("gpview SSR.nc@SSR,time=#{timespan} --mean time --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}SSR.png")
end

if File.exist?("#{prefix}SSRA.png") then
  puts("MESSAGE: #{prefix}SSRA.png exists. process skipped.")
else
  system("gpview SSRA.nc@SSRA,time=#{timespan} --mean time --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}SSRA.png")
end

if File.exist?("#{prefix}SurfAlbedo.png") then
  puts("MESSAGE: #{prefix}SurfAlbedo.png exists. process skipped.")
else
  system("gpview SurfAlbedo.nc@SurfAlbedo,time=#{timespan} --mean time --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}SurfAlbedo.png")
end

if File.exist?("#{prefix}Ps.png") then
  puts("MESSAGE: #{prefix}Ps.png exists. process skipped.")
else
  system("gpview Ps.nc@Ps,time=#{timespan} --mean time --cint=1000 --range=86000:105000 --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}Ps.png")
end

if File.exist?("#{prefix}SurfSnow.png") then
  puts("MESSAGE: #{prefix}SurfSnow.png exists. process skipped.")
else
  system("gpview SurfSnow.nc@SurfSnow,time=#{timespan} --mean time --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}SurfSnow.png")
end

if File.exist?("#{prefix}SeaIceConc.png") then
  puts("MESSAGE: #{prefix}SeaIceConc.png exists. process skipped.")
else
  system("gpview SeaIceConc.nc@SeaIceConc,time=#{timespan} --mean time --wsn=#{wsn} --noannotate && convert -rotate 90 dcl.pdf #{prefix}SeaIceConc.png")
end


# 2 ǡ ʿʬ (noshade)
if File.exist?("#{prefix}SurfTemp-noshade.png") then
  puts("MESSAGE: #{prefix}SurfTemp-noshade.png exists. process skipped.")
else
  system("gpview SurfTemp.nc@SurfTemp,time=#{timespan} --mean time --noshade --wsn=#{wsn} --cint=5 --range=200:320 --noannotate && convert -rotate 90 dcl.pdf #{prefix}SurfTemp-noshade.png")
end

if File.exist?("#{prefix}OLRA-noshade.png") then
  puts("MESSAGE: #{prefix}OLRA-noshade.png exists. process skipped.")
else
  system("gpview OLRA.nc@OLRA,time=#{timespan} --mean time --wsn=#{wsn} --noannotate --cint=10 --range=100:350 --noshade && convert -rotate 90 dcl.pdf #{prefix}OLRA-noshade.png")
end

#  ʿʬ
if File.exist?("#{prefix}Temp_sig0.1.png") then
  puts("MESSAGE: #{prefix}Temp_sig0.1.png exists. process skipped.")
else
  system("gpview Temp.nc@Temp,sig=0.1,time=#{timespan} --mean time --wsn=#{wsn}  --noannotate --sint=10 --range=140:300 && convert -rotate 90 dcl.pdf #{prefix}Temp_sig0.1.png")
end

if File.exist?("#{prefix}Temp_sig0.077.png") then
  puts("MESSAGE: #{prefix}Temp_sig0.077.png exists. process skipped.")
else
  system("gpview Temp.nc@Temp,sig=0.077,time=#{timespan} --mean time --wsn=#{wsn}  --noannotate --sint=10 --range=140:300 && convert -rotate 90 dcl.pdf #{prefix}Temp_sig0.077.png")
end

#  ƻ (itr=2)
if File.exist?("#{prefix}Temp_lat0_itr2.png") then
  puts("MESSAGE: #{prefix}Temp_lat0_itr2.png exists. process skipped.")
else
  system("gpview Temp.nc@Temp,lat=0,time=#{timespan} --mean time --wsn=#{wsn} --itr=2 --noannotate --sint=10 --range=140:300 && convert -rotate 90 dcl.pdf  #{prefix}Temp_lat0_itr2.png")
end

#  ƻ
if File.exist?("#{prefix}Temp_lat0_itr1.png") then
  puts("MESSAGE: #{prefix}Temp_lat0_itr1.png exists. process skipped.")
else
  system("gpview Temp.nc@Temp,lat=0,time=#{timespan} --mean time --wsn=#{wsn} --itr=1 --noannotate --sint=10 --range=140:300 && convert -rotate 90 dcl.pdf #{prefix}Temp_lat0_itr1.png")
end

#  ƻ
if File.exist?("#{prefix}U_lat0_itr1.png") then
  puts("MESSAGE: #{prefix}U_lat0_itr1.png exists. process skipped.")
else
  system("gpview U.nc@U,lat=0,time=#{timespan} --mean time --wsn=#{wsn} --itr=1 --noannotate --cint=15 --range=-70:110 && convert -rotate 90 dcl.pdf #{prefix}U_lat0_itr1.png")
end

#  ʿʬ(sigma=0.077)
if File.exist?("#{prefix}U_sig0.077.png") then
  puts("MESSAGE: #{prefix}U_sig0.077.png exists. process skipped.")
else
  system("gpview U.nc@U,sig=0.077,time=#{timespan} --mean time --wsn=#{wsn}  --noannotate --cint=20 --range=-70:150 && convert -rotate 90 dcl.pdf #{prefix}U_sig0.077.png")
end


#  (ʿʬ)
if File.exist?("#{prefix}V_sig0.1.png") then
  puts("MESSAGE: #{prefix}V_sig0.1.png exists. process skipped.")
else
  system("gpview V.nc@V,sig=0.1,time=#{timespan} --mean time --wsn=#{wsn}  --noannotate --sint=10 --range=-50:50 && convert -rotate 90 dcl.pdf #{prefix}V_sig0.1.png")
end

if File.exist?("#{prefix}V_sig0.077.png") then
  puts("MESSAGE: #{prefix}V_sig0.077.png exists. process skipped.")
else
  system("gpview V.nc@V,sig=0.077,time=#{timespan} --mean time --wsn=#{wsn}  --noannotate --sint=10 --range=-50:50 && convert -rotate 90 dcl.pdf #{prefix}V_sig0.077.png")
end

# ľ ʿʬ
if File.exist?("#{prefix}SigDot_sig0.1.png") then
  puts("MESSAGE: #{prefix}SigDot_sig0.1.png exists. process skipped.")
else
  system("gpview SigDot.nc@SigDot,sigm=0.1,time=#{timespan} --mean time --wsn=#{wsn}  --noannotate --range=-2e-6:2e-6 --cint=1e-7 --clrmap 14 && convert -rotate 90 dcl.pdf #{prefix}SigDot_sig0.1.png")
end

if File.exist?("#{prefix}SigDot_sig0.077.png") then
  puts("MESSAGE: #{prefix}SigDot_sig0.077.png exists. process skipped.")
else
  system("gpview SigDot.nc@SigDot,sigm=0.077,time=#{timespan} --mean time --wsn=#{wsn}  --noannotate --range=-2e-6:2e-6 --cint=1e-7 --clrmap 14 && convert -rotate 90 dcl.pdf #{prefix}SigDot_sig0.077.png")
end

if File.exist?("#{prefix}SigDot_sig0.5.png") then
  puts("MESSAGE: #{prefix}SigDot_sig0.5.png exists. process skipped.")
else
  system("gpview SigDot.nc@SigDot,sigm=0.5,time=#{timespan} --mean time --wsn=#{wsn}  --noannotate --range=-2e-6:2e-6 --cint=1e-7 --clrmap 14 && convert -rotate 90 dcl.pdf #{prefix}SigDot_sig0.5.png")
end


# 漾 ʿʬ
if File.exist?("#{prefix}QVap_sig0.1.png") then
  puts("MESSAGE: #{prefix}QVap_sig0.1.png exists. process skipped.")
else
  system("gpview #{qvap_name}.nc@#{qvap_name},sig=0.1,time=#{timespan} --mean time --wsn=#{wsn}  --noannotate && convert -rotate 90 dcl.pdf #{prefix}QVap_sig0.1.png")
end

if File.exist?("#{prefix}QVap_sig0.077.png") then
  puts("MESSAGE: #{prefix}QVap_sig0.077.png exists. process skipped.")
else
  system("gpview #{qvap_name}.nc@#{qvap_name},sig=0.077,time=#{timespan} --mean time --wsn=#{wsn}  --noannotate && convert -rotate 90 dcl.pdf #{prefix}QVap_sig0.077.png")
end


# ƻ
if File.exist?("#{prefix}QVap_lat0_itr1.png") then
  puts("MESSAGE: #{prefix}QVap_lat0_itr1.png exists. process skipped.")
else
  system("gpview #{qvap_name}.nc@#{qvap_name},lat=0,time=#{timespan} --mean time --wsn=#{wsn} --itr=1 --noannotate --cint=1e-3 --range=1e-19:1e-2 && convert -rotate 90 dcl.pdf #{prefix}QVap_lat0_itr1.png")
end

if File.exist?("#{prefix}QVap_lat0_itr1_Ecolor.png") then
  puts("MESSAGE: #{prefix}QVap_lat0_itr1_Ecolor.png exists. process skipped.")
else
  system("gpview #{qvap_name}.nc@#{qvap_name},lat=0,time=#{timespan} --mean time --wsn=#{wsn} --itr=1 --noannotate --levels 999,1e-4,0.002,0.004,0.006,0.008,0.01,0.012,0.014,0.016,0.018,0.02,999 --pattern 99999,10999,20999,32999,45999,50999,55999,60999,70999,80999,88999,95999  && convert -rotate 90 dcl.pdf #{prefix}QVap_lat0_itr1_Ecolor.png")
end


